package Mcexitexchange;
$VERSION = 1.00;
# Main module for the exit exchange programmed by Marcel Cresnik
$sendmail_path = '/bin/sendmail';

sub connect_database
{
 use DBI;
 return DBI->connect("DBI:mysql:Mcexitexchange", "admin", "admin") or die "Couldn't connect to database\n";
}

sub disconnect_database
{
 my (undef, $dbh) = @_;
 $dbh->disconnect();
}

sub error
{
 my (undef, %args) = @_;
 local $error = $args{error};
 print Mcexitexchange->template(file => 'templates/error.html') or die "Couldn't call template from error\n";
 exit;
}

sub back_error
{
 my (undef, %args) = @_;
 local ($error, $back_link) = ($args{error}, $args{back_link});
 print Mcexitexchange->template(file => 'templates/back_error.html') or die "Couldn't call template from error\n";
 exit;
}

sub template
{
 my (undef, %args) = @_;
 local(*FILE);
 local($file);
 local $error = $args{error}
 	unless $error;
 local $form = $args{form}
 	if defined($args{form});
 local $referrer = $args{referrer}
 	if defined($args{referrer});
 local $sessid = $args{sessid}
 	if defined($args{sessid});
 local($html) = "Content-type: text/html\n\n";;
 $file = $args{file} || die "1 Template not found!\n";
 local $ref = $args{referrer} ? $args{referrer} : 'no';
 open(FILE, "<$file") || die "2 Template not found!\n";
 while (<FILE>)
 {
  $html .= $_;
 }
 close(FILE);
 $html =~ s/\$(\w+)/${$1}/g;
 return $html;
}

sub userpassword_check
{
 my (undef, $username, $pw, $dbh) = @_;
 my $correct_password = $dbh->selectrow_array("SELECT password FROM users WHERE username = '$username'") or die "Database query faild (password_check)!\n";
 my $salt = substr($correct_password, 0, 2);
 my $crypt = crypt($pw, $salt);
 return 1 if crypt($pw, $salt) eq $correct_password;
}

sub create_session
{
 my (undef, $username, $dbh) = @_;
 my $time = time();
 my @random = ('a'..'z', 'A'..'Z', 0..9);
 my $sessid;
 do
 {
  $sessid = undef;
  for (1..10)
  {
   $sessid .= $random[rand @random];
  }
 }
 while (defined($dbh->selectrow_array("SELECT username FROM sessions WHERE sessid = '$sessid'")));
 if (defined($dbh->selectrow_array("SELECT sessid FROM sessions WHERE username = '$username'")))
 {
  $dbh->do("UPDATE sessions SET sessid = '$sessid', time = '$time' WHERE username = '$username'");
 }
 else
 {
  $dbh->do("INSERT INTO sessions (sessid, username, time) VALUES ('$sessid', '$username', $time)")
 	or die "Couldn't insert sessid into MySQL!\n";
 }
 return $sessid;
}

sub recall_session
{
 my (undef, $username, $sessid, $dbh) = @_;
 my $time = time();
 my $logintime = $dbh->selectrow_array("SELECT logintime FROM system WHERE topic = 'system'") or die "Couldn't get logintime!\n";
 my $old_username = $dbh->selectrow_array("SELECT username FROM sessions WHERE sessid = '$sessid'") or die "Session not found!\n";
 my $old_time = $dbh->selectrow_array("SELECT time FROM sessions WHERE sessid = '$sessid'") or die "Session could not be found!\n";
 Mcexitexchange->error(error => 'Your old session could not be recalled.<p>Please re-login!</p><p><a href="get_site.pl?id=login&ref=no">Login</a>')
 	unless (defined($username) && ($old_time + $logintime > $time) && $username eq $old_username);
}

1;
