#!/usr/bin/perl

use Mcexitexchange;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);

$dbh = Mcexitexchange->connect_database;
($username, $sessid) = (lc(url_param('username')), url_param('sessid'));
Mcexitexchange->recall_session($username, $sessid, $dbh);
$old_password = lc(param('old_password'));
$new_password1 = lc(param('new_password1'));
$new_password2 = lc(param('new_password2'));
$first_name = param('first_name');
$last_name = param('last_name');
$email = param('email');

unless (Mcexitexchange->userpassword_check($username, $old_password, $dbh))
{
 $error = 'The password you entered is wrong!';
 &form_error;
 exit;
}
if ($new_password1 && (length($new_password1) < 5 || length($new_password1) > 15))
{
 $error = 'The new password is either too short or too long!';
 &form_error;
 exit;
}
if ($new_password1 && $new_password1 ne $new_password2)
{
 $error = 'You have entered two different passwords!';
 &form_error;
 exit;
}
unless ($first_name)
{
 $error = 'Please enter your first name!';
 &form_error;
 exit;
}
unless ($last_name)
{
 $error = 'Please enter your last name!';
 &form_error;
 exit;
}
unless ($email)
{
 $error = 'Please enter your E-Mail!';
 &form_error;
 exit;
}
if (length($first_name) > 16)
{
 $error = 'The first name you entered is too long!';
 &form_error;
 exit;
}
if (length($last_name) > 16)
{
 $error = 'The last name you entered is too long!';
 &form_error;
 exit;
}
if ($new_password1)
{
 @salt = ('a'..'z', 'A'..'Z', 0..9);
 $salt = $salt[rand @salt] . $salt[rand @salt];
 $password_crypted = crypt($new_password1, $salt);
 $dbh->do("UPDATE users SET password = '$password_crypted' WHERE username = '$username'");
}
$dbh->do("UPDATE users SET first_name = '$first_name', last_name = '$last_name', email = '$email' WHERE username = '$username'");
Mcexitexchange->disconnect_database($dbh);
print redirect("account.pl?username=$username&sessid=$sessid");

sub form_error
{
 $form = "<table width=\"80%\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\"><form action=apply_accountchanges.pl?username=$username&sessid=$sessid method=post>
						<tr>
							<td>
								<div align=\"right\">
									Username (cannot be changed):</div>
							</td>
							<td><input type=text name=username value=\"$username\" size=20 readonly></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									Old password:</div>
							</td>
							<td><input type=password name=old_password size=20 maxlength=14></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									New password (leave blank to keep old password):</div>
							</td>
							<td><input type=password name=new_password1 size=20 maxlength=14></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									Repeat new password (leave blank to keep old one):</div>
							</td>
							<td><input type=password name=new_password2 size=20 maxlength=14></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									First name:</div>
							</td>
							<td><input type=text name=first_name value=\"$first_name\" size=20 maxlength=16></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									Last name:</div>
							</td>
							<td><input type=text name=last_name value=\"$last_name\" size=20 maxlength=16></td>
						</tr>
						<tr>
							<td>
								<div align=\"right\">
									E-Mail:</div>
							</td>
							<td><input type=text name=email value=\"$email\" size=30></td>
						</tr>
							<tr>
								<td colspan=\"2\"><br>
									<div align=\"center\">
										<input type=submit value=\"Apply changes!\">
									</div>
								</td>
							</tr>
						
					</table>";
 print template('templates/form_error.html');
 Mcexitexchange->disconnect_database($dbh);
}

sub template
{
 my ($file) = $_[0];
 local($html) = "Content-type: text/html\n\n";;
 open(FILE, "<$file") || die "2 Template not found!\n";
 while (<FILE>)
 {
  $html .= $_;
 }
 close(FILE);
 $html =~ s/\$(\w+)/${$1}/g;
 return $html;
}
